.486
.model flat, stdcall
option casemap:none

	include	MsgBox.inc

	InterceptFunctions 	proto
	SetGlobalHook 		proto fInstall:dword

.code

DllEntry proc hInst:dword, reason:dword, unused:dword
	.if reason == DLL_PROCESS_ATTACH
 		mov	eax, hInst
 		mov	hInstance, eax

 		invoke GetCurrentProcess
 		mov hcProcess, eax

 		call InterceptFunctions

 	.elseif reason == DLL_PROCESS_DETACH
 		call RestoreFunctions						;  
 	.endif

	mov eax, TRUE
	ret
DllEntry endp

InterceptFunctions proc
	invoke GetModuleHandle, offset sModuleName			;  hModule
	invoke GetProcAddress, eax, offset sFunctnName		;   

	or eax, eax											;   
	jz @ret

	mov adr_APIFunction, eax							;  ...

	mov jump.instr_push, 68h							; push 			\
	mov jump.arg, Intercept_MessageBoxA					;    	: = 6 
	mov jump.instr_ret, 0C3h							; ret				   /
 														;    oldData,  
  	invoke ReadProcessMemory, hcProcess, adr_APIFunction, addr oldData, sizeof jump, addr written 

	cmp written, sizeof jump							;  ,    6  "" ...
	jne	@ret
 														;    "" 
	invoke WriteProcessMemory, hcProcess, adr_APIFunction, addr jump, sizeof jump, addr written
	
	xor eax, eax
	cmp written, sizeof jump
	jne	@ret
	mov eax, TRUE
	
@ret:
	ret
InterceptFunctions endp

RestoreFunctions proc
	invoke WriteProcessMemory, hcProcess, adr_APIFunction, addr oldData, sizeof jump, addr written
	
	xor eax, eax										;  True,  
	cmp written, sizeof jump
	jne @ret
	mov eax, TRUE 	
@ret:
	ret
RestoreFunctions endp

Intercept_MessageBoxA proc hWnd:dword, dwText:dword, dwCaption:dword, uType:dword
	call RestoreFunctions
	or eax, eax
	jz @ret

	or uType, MB_ABORTRETRYIGNORE

	push uType
	push dwCaption
	push dwText
	push hWnd
	call adr_APIFunction
	push eax							;   
	
	invoke WriteProcessMemory, hcProcess, adr_APIFunction, addr jump, sizeof jump, addr written
	
	pop eax
@ret:
	ret
Intercept_MessageBoxA endp

cbEmptyProc proc nCode:dword, wParam:dword, lParam:dword
	invoke CallNextHookEx, hHook, nCode, wParam, lParam
	ret
cbEmptyProc endp

ModuleFromAddress proc pv:dword
	LOCAL mbi:MEMORY_BASIC_INFORMATION

	xor eax, eax
	invoke VirtualQuery, pv, addr mbi, sizeof mbi

	or eax, eax
	jz	@ret

	mov eax, mbi.AllocationBase
@ret:
	ret
ModuleFromAddress endp

SetGlobalHook proc fInstall:dword

	cmp fInstall, FALSE
	jz	unhook									;    ?

	cmp hHook, NULL
	jnz	@ret									;    

	or eax, eax
	jz	@ret									;   

	invoke ModuleFromAddress, SetGlobalHook		;  
	invoke SetWindowsHookEx, WH_GETMESSAGE, cbEmptyProc, eax, 0h

	mov hHook, eax 
	jmp @ret									; , 

unhook:
	invoke UnhookWindowsHookEx, hHook			;  
	mov hHook, NULL

@ret:
	ret
SetGlobalHook endp

End DllEntry